<?php 
/*
Plugin Name: PT iMate Shortcodes
Plugin URI: #
Version: 1.0.0
Author: Promo Theme
Author URI: #
*/

if(!class_exists('WPBakeryShortCode')) {
    return false;
}

add_action( 'vc_before_init', 'pt_imate_shortcodes_init' );
add_action( 'vc_before_init', 'pt_functions' );
add_action( 'after_setup_theme', 'load_widgets' );

function pt_imate_shortcodes_init() {
	// Include Params

	$dir = dirname(__FILE__)."/params";
	$dh = opendir($dir);
	while ($filename = readdir($dh)) {
	    if (($filename !== '.') && ($filename !== '..')) {
	        $filename = $dir."/".$filename;
	        include_once($filename);
	    }
	}

	closedir($dh);

	// Include Shortcodes

	$dir = dirname(__FILE__)."/shortcodes";
	$dh = opendir($dir);
	while ($filename = readdir($dh)) {
	    if (($filename !== '.') && ($filename !== '..')) {
	        $filename = $dir."/".$filename;
	        include_once($filename);
	    }
	}

	closedir($dh);

	
}

add_action('wp_footer', 'pt_imate_st'); 

function pt_imate_st() {
	if(function_exists('imate_styles')) {
		if(!empty(imate_styles()['color_scheme'])) {
			echo '<style>
				.dddddd {
					box-shadow: inset 0 0 0 3px #fff, inset 0 0 0 18px '.imate_styles()['color_scheme1'].';
				}

				.dddddd { background: '.imate_styles()['color_scheme1'].' }

				.dddddd { border-color: '.imate_styles()['color_scheme1'].' }

				.dddddd { color: '.imate_styles()['color_scheme'].' }

				.site-footer .square-bg-block {
					background-image: -webkit-repeating-linear-gradient(to bottom, transparent, transparent 3px, #0e1116 3px, #0e1116 30px),
			        -webkit-repeating-linear-gradient(to right, '.imate_styles()['color_scheme'].', '.imate_styles()['color_scheme'].' 3px, #28487d00 3px, #28487d00 30px);
			    background-image: -moz-repeating-linear-gradient(to bottom, transparent, transparent 3px, #0e1116 3px, #0e1116 30px),
			        -moz-repeating-linear-gradient(to right, '.imate_styles()['color_scheme'].', '.imate_styles()['color_scheme'].' 3px, #28487d00 3px, #28487d00 30px);
			    background-image: -ms-repeating-linear-gradient(to bottom, transparent, transparent 3px, #0e1116 3px, #0e1116 30px),
			        -ms-repeating-linear-gradient(to right, '.imate_styles()['color_scheme'].', '.imate_styles()['color_scheme'].' 3px, #28487d00 3px, #28487d00 30px);
			    background-image: repeating-linear-gradient(to bottom, transparent, transparent 3px, #0e1116 3px, #0e1116 30px),
			        repeating-linear-gradient(to right, '.imate_styles()['color_scheme'].', '.imate_styles()['color_scheme'].' 3px, #28487d00 3px, #28487d00 30px);
				}
			</style>';
		}
	}
}

// Include likes
require dirname(__FILE__) . '/include/zilla-likes.php';
require dirname(__FILE__) . '/include/video-parser.php';

function imate_scripts2() {
	if (!is_admin()) {
    	wp_deregister_script('wpb_composer_front_js');
        wp_dequeue_script('wpb_composer_front_js');
    }
    
	wp_enqueue_script( 'js_composer_front', get_template_directory_uri() . '/js/js_composer_front.min.js', array('jquery'), '', true );

}
add_action( 'wp_enqueue_scripts', 'imate_scripts2', 100000 );
	

function pt_functions() {
	function get_all_portfolio_category() {
	    $taxonomy = 'fw-portfolio-category';
	    $args     = array(
	        'hide_empty' => true,
	    );

	    $terms     = get_terms( $taxonomy, $args );
	    $result    = array();
	    $result[0] = "";

	    if ( ! empty( $terms ) && !is_wp_error( $terms ) ) {
	        foreach ( $terms as $term ) {
	        	$name = get_category_parents($term->term_id);
	            if(empty($name)) {
	            	$name = $term->name;
	            }
	            $name = trim($name, '/');
	            $result[ 'ID ['.$term->term_id.'] '.$name ] = $term->term_id;
	        }
	    }

	    return $result;
	}

	function get_all_blog_category() {
	    $taxonomy = 'category';
	    $args     = array(
	        'hide_empty' => true,
	    );

	    $terms     = get_terms( $taxonomy, $args );
	    $result    = array();
	    $result[0] = "";

	    if ( ! empty( $terms ) && !is_wp_error( $terms ) ) {
	        foreach ( $terms as $term ) {
	            $name = get_category_parents($term->term_id);
	            if(empty($name)) {
	            	$name = $term->name;
	            }
	            $name = trim($name, '/');
	            $result[ 'ID ['.$term->term_id.'] '.$name ] = $term->term_id;
	        }
	    }

	    return $result;
	}

	function get_all_product_category() {
	    $taxonomy = 'product_cat';
	    $args     = array(
	        'hide_empty' => true,
	    );

	    $terms     = get_terms( $taxonomy, $args );
	    $result    = array();
	    $result[0] = "";

	    if ( ! empty( $terms ) && !is_wp_error( $terms ) ) {
	        foreach ( $terms as $term ) {
	            $name = get_category_parents($term->term_id);
	            if(empty($name)) {
	            	$name = $term->name;
	            }
	            $name = trim($name, '/');
	            $result[ 'ID ['.$term->term_id.'] '.$name ] = $term->term_id;
	        }
	    }

	    return $result;
	}

	function get_all_portfolio_items( $param = 'All' ) {
	    $result    = array();
	    
	    $args = array(
	        'post_type'       => 'fw-portfolio',
	        'post_status'     => 'publish',
	        'posts_per_page'    => '10000'
	    );

	    $porfolio_array = new WP_Query( $args );
	    $result[0] = "";

	    if ( ! empty( $porfolio_array->posts ) ) {
	        foreach ( $porfolio_array->posts as $item ) {
	            $result[ 'ID ['.$item->ID.'] '. $item->post_title ] = $item->ID;
	        }
	    }

	    return $result;
	}

	function get_all_blog_items( $param = 'All' ) {
	    $result    = array();
	    
	    $args = array(
	        'post_type'       => 'post',
	        'post_status'     => 'publish',
	        'posts_per_page'    => '10000'
	    );

	    $porfolio_array = new WP_Query( $args );
	    $result[0] = "";

	    if ( ! empty( $porfolio_array->posts ) ) {
	        foreach ( $porfolio_array->posts as $item ) {
	            $result[ 'ID ['.$item->ID.'] '. $item->post_title ] = $item->ID;
	        }
	    }

	    return $result;
	}

	function pt_hex2rgba($color, $opacity = false) {
 
		$default = 'rgb(0,0,0)';

		if(empty($color))
			return $default; 

		if ($color[0] == '#' ) {
			$color = substr( $color, 1 );
		}

		if (strlen($color) == 6) {
			$hex = array( $color[0] . $color[1], $color[2] . $color[3], $color[4] . $color[5] );
		} elseif ( strlen( $color ) == 3 ) {
			$hex = array( $color[0] . $color[0], $color[1] . $color[1], $color[2] . $color[2] );
		} else {
			return $default;
		}

		$rgb =  array_map('hexdec', $hex);

		if(!empty($opacity)){
			if(abs($opacity) > 1) {
				$opacity = 1.0;
			}
			$output = 'rgba('.implode(",",$rgb).','.$opacity.')';
		} else {
			$output = 'rgb('.implode(",",$rgb).')';
		}

		return $output;
	}
    
    function pt_get_pattern( $text ) {
        $pattern = get_shortcode_regex();
        preg_match_all( "/$pattern/s", $text, $c );
        return $c;
    }

    function pt_parse_atts( $content ) {
        $content = preg_match_all( '/([^ ]*)=(\'([^\']*)\'|\"([^\"]*)\"|([^ ]*))/', trim( $content ), $c );
        list( $dummy, $keys, $values ) = array_values( $c );
        $c = array();
        foreach ( $keys as $key => $value ) {
            $value = trim( $values[ $key ], "\"'" );
            $type = is_numeric( $value ) ? 'int' : 'string';
            $type = in_array( strtolower( $value ), array( 'true', 'false' ) ) ? 'bool' : $type;
            switch ( $type ) {
                case 'int': $value = (int) $value; break;
                case 'bool': $value = strtolower( $value ) == 'true'; break;
            }
            $c[ $keys[ $key ] ] = $value;
        }
        return $c;
    }

    function pt_the_shortcodes( &$output, $text, $child = false ) {

        $patts = pt_get_pattern( $text );
        $t = array_filter( pt_get_pattern( $text ) );
        if ( ! empty( $t ) ) {
            list( $d, $d, $parents, $atts, $d, $contents ) = $patts;
            $out2 = array();
            $n = 0;
            foreach( $parents as $k=>$parent ) {
                ++$n;
                $name = $child ? 'child' . $n : $n;
                $t = array_filter( pt_get_pattern( $contents[ $k ] ) );
                $t_s = pt_the_shortcodes( $out2, $contents[ $k ], true );
                $output[ $name ] = pt_parse_atts( $atts[ $k ] );
            }
        }
        return array_values( $output );
    }

    function pt_hex_is_light( $color ) {
		$hex = str_replace( '#', '', $color );

		$c_r = hexdec( substr( $hex, 0, 2 ) );
		$c_g = hexdec( substr( $hex, 2, 2 ) );
		$c_b = hexdec( substr( $hex, 4, 2 ) );

		$brightness = ( ( $c_r * 299 ) + ( $c_g * 587 ) + ( $c_b * 114 ) ) / 1000;

		return $brightness > 195;
	}

	function pt_share_buttons($post_id = '') {
		if(empty($post_id)) return false;

		$title = get_the_title($post_id);
		$link = get_permalink($post_id);
		$links = '';

		if(true) {
			$links .= '<a href="http://www.facebook.com/sharer.php?u='.$link.'" target="_blank"><i class="fa fa-facebook"></i></a>';
		}
		if(true) {
			$links .= '<a href="http://pinterest.com/pin/create/button/?url='.$link.'" target="_blank"><i class="fa fa-pinterest"></i></a>';
		}
		if(true) {
			$links .= '<a href="https://plus.google.com/share?url='.$link.'" target="_blank"><i class="fa fa-google-plus"></i></a>';
		}
		if(true) {
			$links .= '<a href="https://www.tumblr.com/widgets/share/tool?canonicalUrl='.$link.'&title='.$title.'" target="_blank"><i class="fa fa-tumblr"></i></a>';
		}
		if(true) {
			$links .= '<a href="https://twitter.com/intent/tweet?url='.$link.'" target="_blank"><i class="fa fa-twitter"></i></a>';
		}

		return '<div class="social-buttons">'.wp_kses_post($links).'</div>';
	}
}


function load_widgets() {
	/**
	 * Portfolio widget
	 */
	class imate_portfolio_widget extends WP_Widget {
	 
		function __construct() {
			parent::__construct(
				'portfolio', 
				'Portfolio'
			);
		}
	 
		public function widget( $args, $instance ) {
			$title = $instance['title'];
			$amount = $instance['amount'];
			$cols = $instance['cols'];
			$orderby = $instance['orderby'];
			$order = $instance['order'];
			$link = $instance['link'];
	 
			switch ($cols) {
				case '1':
				$class = "col-xs-12";
				break;
				case '2':
				$class = "col-xs-6 col-sm-6";
				break;
				case '3':
				$class = "col-xs-4";
				break;
				case '4':
				$class = "col-xs-6 col-md-3";
				break;

				default:
				$class = "";
				break;
			}

			$porfolio_array = get_posts( array(
				'numberposts'     => $amount,
				'orderby'         => $orderby,
				'order'           => $order,
				'post_type'       => 'fw-portfolio',
				'post_status'     => 'publish'
				)
			);

			echo wp_kses_post($args['before_widget']);
			if ( ! empty( $title ) ) echo wp_kses_post($args['before_title'] . strip_tags($title) . $args['after_title']);
			?>
				<div class="gallery-module row">
					<?php foreach ($porfolio_array as $item) {
						setup_postdata($item);
						$id = $item->ID;
						$name = $item->post_title;

						$thumb = get_post_meta( $id, '_thumbnail_id', true );

						$link = get_permalink($id);
					?>
					<div class="<?php echo esc_attr($class) ?> item"><a href="<?php echo esc_url($link) ?>"><?php echo wp_get_attachment_image( $thumb , 'thumbnail', true, array('title'=>$name) ) ?></a></div>
					<?php } ?>
				</div>
				<div class="gallery-module-button"><a href="<?php echo esc_url($link) ?>" class="button-style4"><i class="social-media-elements-instagram"></i><span><?php echo esc_html__('follow us', 'imate') ?></span></a></div>
			<?php
			echo wp_kses_post($args['after_widget']);
		}
	 
		public function form( $instance ) {
			$title = "";
			if ( isset( $instance[ 'title' ] ) ) {
				$title = $instance[ 'title' ];
			}
			$amount = "";
			if ( isset( $instance[ 'amount' ] ) ) {
				$amount = $instance[ 'amount' ];
			}
			$cols = "";
			if ( isset( $instance[ 'cols' ] ) ) {
				$cols = $instance[ 'cols' ];
			}
			$orderby = "";
			if ( isset( $instance[ 'orderby' ] ) ) {
				$orderby = $instance[ 'orderby' ];
			}
			$order = "";
			if ( isset( $instance[ 'order' ] ) ) {
				$order = $instance[ 'order' ];
			}
			$link = "";
			if ( isset( $instance[ 'link' ] ) ) {
				$link = $instance[ 'link' ];
			}
			?>
			<p>
				<label for="<?php echo esc_html($this->get_field_id( 'title' )); ?>"><?php esc_html_e( 'Heading:', 'imate') ?></label> 
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_html($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</p>
			<p>
				<label for="<?php echo esc_html($this->get_field_id( 'amount' )); ?>"><?php esc_html_e( 'Amount:', 'imate') ?></label> 
				<input id="<?php echo esc_html($this->get_field_id( 'amount' )); ?>" name="<?php echo esc_html($this->get_field_name( 'amount' )); ?>" type="number" value="<?php echo ($amount) ? esc_attr( $amount ) : '9'; ?>" size="3" />
			</p>
			<p>
				<label for="<?php echo esc_html($this->get_field_id( 'cols' )); ?>"><?php esc_html_e( 'Cols:', 'imate') ?></label> 
				<input id="<?php echo esc_html($this->get_field_id( 'cols' )); ?>" name="<?php echo esc_html($this->get_field_name( 'cols' )); ?>" type="number" value="<?php echo ($cols) ? esc_attr( $cols ) : '3'; ?>" size="3" />
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'orderby' )); ?>"><?php esc_html_e( 'Order by:', 'imate') ?></label>
				<select name="<?php echo esc_attr($this->get_field_name( 'orderby' )); ?>" id="<?php echo esc_attr($this->get_field_id( 'orderby' )); ?>">
					<option value="date" <?php echo ($orderby =='date')?'selected':''; ?>><?php echo esc_html__('Date' ,'imate') ?></option>
					<option value="author" <?php echo ($orderby =='author')?'selected':''; ?>><?php echo esc_html__('Author' ,'imate') ?></option>
					<option value="category" <?php echo ($orderby =='category')?'selected':''; ?>><?php echo esc_html__('Category' ,'imate') ?></option>
					<option value="ID" <?php echo ($orderby =='ID')?'selected':''; ?>><?php echo esc_html__('ID' ,'imate') ?></option>
					<option value="title" <?php echo ($orderby =='title')?'selected':''; ?>><?php echo esc_html__('Title' ,'imate') ?></option>
				</select>
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'order' )); ?>"><?php esc_html_e( 'Order:', 'imate') ?></label>
				<select name="<?php echo esc_attr($this->get_field_name( 'order' )); ?>" id="<?php echo esc_attr($this->get_field_id( 'order' )); ?>">
					<option value="DESC"<?php echo ($order =='DESC')?'selected':''; ?>><?php echo esc_html__('Descending order' ,'imate') ?></option>
					<option value="ASC"<?php echo ($order =='ASC')?'selected':''; ?>><?php echo esc_html__('Ascending order' ,'imate') ?></option>
				</select>
			</p>
			<p>
				<label for="<?php echo esc_html($this->get_field_id( 'link' )); ?>"><?php esc_html_e( 'Link:', 'imate') ?></label> 
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'link' )); ?>" name="<?php echo esc_html($this->get_field_name( 'link' )); ?>" type="text" value="<?php echo esc_attr( $link ); ?>" />
			</p>
			<?php 
		}
	 
		public function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
			$instance['amount'] = ( is_numeric( $new_instance['amount'] ) ) ? $new_instance['amount'] : '8';
			$instance['cols'] = ( is_numeric( $new_instance['cols'] ) ) ? $new_instance['cols'] : '5';
			$instance['orderby'] = ( !empty( $new_instance['orderby'] ) ) ? $new_instance['orderby'] : 'date';
			$instance['order'] = ( !empty( $new_instance['order'] ) ) ? $new_instance['order'] : 'DESC';
			$instance['link'] = ( !empty( $new_instance['link'] ) ) ? $new_instance['link'] : '';
			return $instance;
		}
	}

	function imate_portfolio_widget() {
		register_widget( 'imate_portfolio_widget' );
	}
	add_action( 'widgets_init', 'imate_portfolio_widget' );

	class imate_social_buttons_widget extends WP_Widget {
	 
		function __construct() {
			parent::__construct(
				'social_buttons', 
				'Social buttons'
			);
		}
	 
		public function widget( $args, $instance ) {
			$title = $instance['title'];
			if(function_exists('imate_styles') && !empty(imate_styles()['social_buttons_content'])) {
				echo '<div class="social-buttons-widget widget">';
					if ( ! empty( $title ) ) echo wp_kses_post($args['before_title'] . $title . $args['after_title']);
					
					echo '<div class="social-buttons">'.imate_styles()['social_buttons_content'].'</div>';

				echo '</div>';
			}
		}

		public function form( $instance ) {
			$title = "";
			if ( isset( $instance[ 'title' ] ) ) {
				$title = $instance[ 'title' ];
			}
			?>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php esc_html_e( 'Heading:', 'imate') ?></label> 
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</p>
			<?php 
		}

		public function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
			return $instance;
		}
	}

	function imate_social_buttons_widget() {
		register_widget( 'imate_social_buttons_widget' );
	}
	add_action( 'widgets_init', 'imate_social_buttons_widget' );


	/**
	 * Blog post widget
	 */
	class imate_blog_post_widget extends WP_Widget {
	 
		function __construct() {
			parent::__construct(
				'blog_post', 
				'Blog posts'
			);
		}
	 
		public function widget( $args, $instance ) {
			$title = $instance['title'];
			$amount = $instance['amount'];
			$orderby = $instance['orderby'];
			$order = $instance['order'];
			$display_image = $instance['display_image'];
			$display_date = $instance['display_date'];


			$post_array = get_posts( array(
				'numberposts'     => $amount,
				'orderby'         => $orderby,
				'order'           => $order,
				'post_type'       => 'post',
				'post_status'     => 'publish'
				)
			);

			echo wp_kses_post($args['before_widget']);
			if ( ! empty( $title ) ) echo wp_kses_post($args['before_title'] . strip_tags($title) . $args['after_title']);
			?>
			<div class="blog-post-widget widget">
				<?php foreach ($post_array as $item) {
					setup_postdata($item);
					$id = $item->ID;
					$name = $item->post_title;

					$thumb = get_post_meta( $id, '_thumbnail_id', true );
					$image_array = wp_get_attachment_image_src( $thumb , 'thumbnail' )[0];
				?>
				<div class="item">
					<?php if($display_image == "yes" && isset($image_array) && !empty($image_array)) { ?>
					<a href="<?php echo esc_url(get_permalink($id)) ?>" class="image" style="background-image: url(<?php echo esc_url($image_array) ?>)"></a>
					<?php } ?>
					<div class="text">
						<a href="<?php echo esc_url(get_permalink($id)) ?>" class="name"><?php echo esc_html($name) ?></a>
						<?php if($display_date == "yes") { ?>
							<div class="blog-detail"><span><?php echo get_the_date('', $id) ?></span></div>
						<?php } ?>
					</div>
				</div>
				<?php } ?>
			</div>
			<?php
			echo wp_kses_post($args['after_widget']);
		}
	 
		public function form( $instance ) {
			$title = "";
			if ( isset( $instance[ 'title' ] ) ) {
				$title = $instance[ 'title' ];
			}
			$amount = "";
			if ( isset( $instance[ 'amount' ] ) ) {
				$amount = $instance[ 'amount' ];
			}
			$orderby = "";
			if ( isset( $instance[ 'orderby' ] ) ) {
				$orderby = $instance[ 'orderby' ];
			}
			$order = "";
			if ( isset( $instance[ 'order' ] ) ) {
				$order = $instance[ 'order' ];
			}
			$display_image = "";
			if ( isset( $instance[ 'display_image' ] ) ) {
				$display_image = $instance[ 'display_image' ];
			}
			$display_date = "";
			if ( isset( $instance[ 'display_date' ] ) ) {
				$display_date = $instance[ 'display_date' ];
			}
			?>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php esc_html_e( 'Heading:', 'imate') ?></label> 
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'amount' )); ?>"><?php esc_html_e( 'Number posts:', 'imate') ?></label> 
				<input id="<?php echo esc_attr($this->get_field_id( 'amount' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'amount' )); ?>" type="number" value="<?php echo ($amount) ? esc_attr( $amount ) : '3'; ?>" size="3" />
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'orderby' )); ?>"><?php esc_html_e( 'Order by:', 'imate') ?></label>
				<select name="<?php echo esc_attr($this->get_field_name( 'orderby' )); ?>" id="<?php echo esc_attr($this->get_field_id( 'orderby' )); ?>">
					<option value="date" <?php echo ($orderby =='date')?'selected':''; ?>><?php echo esc_html__('Date' ,'imate') ?></option>
					<option value="author" <?php echo ($orderby =='author')?'selected':''; ?>><?php echo esc_html__('Author' ,'imate') ?></option>
					<option value="category" <?php echo ($orderby =='category')?'selected':''; ?>><?php echo esc_html__('Category' ,'imate') ?></option>
					<option value="ID" <?php echo ($orderby =='ID')?'selected':''; ?>><?php echo esc_html__('ID' ,'imate') ?></option>
					<option value="title" <?php echo ($orderby =='title')?'selected':''; ?>><?php echo esc_html__('Title' ,'imate') ?></option>
				</select>
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'order' )); ?>"><?php esc_html_e( 'Order:', 'imate') ?></label>
				<select name="<?php echo esc_attr($this->get_field_name( 'order' )); ?>" id="<?php echo esc_attr($this->get_field_id( 'order' )); ?>">
					<option value="DESC"<?php echo ($order =='DESC')?'selected':''; ?>><?php echo esc_html__('Descending order' ,'imate') ?></option>
					<option value="ASC"<?php echo ($order =='ASC')?'selected':''; ?>><?php echo esc_html__('Ascending order' ,'imate') ?></option>
				</select>
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'display_image' )); ?>"><?php esc_html_e( 'Image:', 'imate') ?></label>
				<select name="<?php echo esc_attr($this->get_field_name( 'display_image' )); ?>" id="<?php echo esc_attr($this->get_field_id( 'display_image' )); ?>">
					<option value="yes"<?php echo ($display_image =='yes')?'selected':''; ?>><?php echo esc_html__('Yes' ,'imate') ?></option>
					<option value="no"<?php echo ($display_image =='no')?'selected':''; ?>><?php echo esc_html__('No' ,'imate') ?></option>
				</select>
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'display_date' )); ?>"><?php esc_html_e( 'Date:', 'imate') ?></label>
				<select name="<?php echo esc_attr($this->get_field_name( 'display_date' )); ?>" id="<?php echo esc_attr($this->get_field_id( 'display_date' )); ?>">
					<option value="yes"<?php echo ($display_date =='yes')?'selected':''; ?>><?php echo esc_html__('Yes' ,'imate') ?></option>
					<option value="no"<?php echo ($display_date =='no')?'selected':''; ?>><?php echo esc_html__('No' ,'imate') ?></option>
				</select>
			</p>

			<?php 
		}
	 
		public function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
			$instance['amount'] = ( is_numeric( $new_instance['amount'] ) ) ? $new_instance['amount'] : '2';
			$instance['orderby'] = ( !empty( $new_instance['orderby'] ) ) ? $new_instance['orderby'] : 'date';
			$instance['order'] = ( !empty( $new_instance['order'] ) ) ? $new_instance['order'] : 'DESC';
			$instance['display_image'] = ( !empty( $new_instance['display_image'] ) ) ? $new_instance['display_image'] : 'yes';
			$instance['display_date'] = ( !empty( $new_instance['display_date'] ) ) ? $new_instance['display_date'] : 'yes';
			return $instance;
		}
	}

	function imate_blog_post_widget() {
		register_widget( 'imate_blog_post_widget' );
	}
	add_action( 'widgets_init', 'imate_blog_post_widget' );


	class imate_about_me_widget extends WP_Widget {
	 
		function __construct() {
			add_action('admin_enqueue_scripts', array($this, 'scripts'));

			parent::__construct(
				'about_me', 
				'About Me'
			);
		}

		public function widget( $args, $instance ) {
		   // Our variables from the widget settings
			$title = apply_filters( 'widget_title', empty( $instance['title'] ) ? '' : $instance['title'] );
			$image = ! empty( $instance['image'] ) ? $instance['image'] : '';
			$sub_title = ! empty( $instance['sub_title'] ) ? $instance['sub_title'] : '';
			$description = ! empty( $instance['description'] ) ? $instance['description'] : '';
			$social_links = ! empty( $instance['social_links'] ) ? $instance['social_links'] : 'yes';

			ob_start();
			echo wp_kses_post($args['before_widget']);
			?>

			<?php if($image) { ?>
				<div class="image" style="background-image: url(<?php echo esc_url($image); ?>)"></div>
			<?php } if(!empty($title)) { ?>
				<h6 class="h"><?php echo wp_kses_post($title) ?></h6>
			<?php } if(!empty($sub_title)) { ?>
				<div class="sub-h"><?php echo wp_kses_post($sub_title) ?></div>
			<?php } if(!empty($description)) { ?>
				<div class="desc"><?php echo wp_kses_post($description) ?></div>
			<?php } if($social_links == 'yes' && !empty(imate_styles()['social_buttons_content'])) { ?>
				<div class="social-buttons"><?php echo wp_kses_post(imate_styles()['social_buttons_content']) ?></div>
			<?php } ?>

			<?php
			echo wp_kses_post($args['after_widget']);
			ob_end_flush();
		}

		public function form( $instance ) {
			$title = ! empty( $instance['title'] ) ? $instance['title'] : '';
			$sub_title = ! empty( $instance['sub_title'] ) ? $instance['sub_title'] : '';
			$description = ! empty( $instance['description'] ) ? $instance['description'] : '';
			$social_links = ! empty( $instance['social_links'] ) ? $instance['social_links'] : 'yes';
			$image = ! empty( $instance['image'] ) ? $instance['image'] : '';
			?>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'title' )); ?>"><?php echo esc_html__( 'Title:', 'imate' ); ?></label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'title' )); ?>" type="text" value="<?php echo esc_attr( $title ); ?>">
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'sub_title' )); ?>"><?php echo esc_html__( 'Sub Title:', 'imate' ); ?></label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'sub_title' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'sub_title' )); ?>" type="text" value="<?php echo esc_attr( $sub_title ); ?>">
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'description' )); ?>"><?php echo esc_html__( 'Description:', 'imate' ); ?></label>
				<textarea class="widefat" id="<?php echo esc_attr($this->get_field_id( 'description' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'description' )); ?>"><?php echo wp_kses_post( $description ); ?></textarea>
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'social_links' )); ?>"><?php esc_html_e( 'Show Social Links:', 'imate') ?></label>
				<select name="<?php echo esc_attr($this->get_field_name( 'social_links' )); ?>" id="<?php echo esc_attr($this->get_field_id( 'social_links' )); ?>">
					<option value="yes" <?php echo ($social_links =='yes')?'selected':''; ?>><?php echo esc_html__('Yes' ,'imate') ?></option>
					<option value="no" <?php echo ($social_links =='no')?'selected':''; ?>><?php echo esc_html__('No' ,'imate') ?></option>
				</select>
			</p>
			<p>
				<label for="<?php echo esc_attr($this->get_field_id( 'image' )); ?>"><?php echo esc_html__( 'Image:', 'imate' ); ?></label>
				<input class="widefat" id="<?php echo esc_attr($this->get_field_id( 'image' )); ?>" name="<?php echo esc_attr($this->get_field_name( 'image' )); ?>" type="text" value="<?php echo esc_url( $image ); ?>" />
				<button class="upload_image_button button button-primary"><?php echo esc_html__('Upload Image', 'imate') ?></button>
			</p>
			<?php
		}

		public function update( $new_instance, $old_instance ) {
			$instance = array();
			$instance['title'] = ( ! empty( $new_instance['title'] ) ) ? strip_tags( $new_instance['title'] ) : '';
			$instance['image'] = ( ! empty( $new_instance['image'] ) ) ? $new_instance['image'] : '';
			$instance['sub_title'] = ( ! empty( $new_instance['sub_title'] ) ) ? $new_instance['sub_title'] : '';
			$instance['description'] = ( ! empty( $new_instance['description'] ) ) ? $new_instance['description'] : '';
			$instance['social_links'] = ( ! empty( $new_instance['social_links'] ) ) ? $new_instance['social_links'] : '';

			return $instance;
		}

		public function scripts() {
			wp_enqueue_script( 'media-upload' );
			wp_enqueue_media();
			wp_enqueue_script('imate-admin-media', get_template_directory_uri() . '/js/admin-media.js', array('jquery'));
		}
	}

	function imate_about_me_widget() {
		register_widget( 'imate_about_me_widget' );
	}
	add_action( 'widgets_init', 'imate_about_me_widget' );

	

	add_filter('style_loader_tag', 'imate_remove_type_attr', 10, 2);
	add_filter('script_loader_tag', 'imate_remove_type_attr', 10, 2);
	function imate_remove_type_attr($tag, $handle) {
	    return preg_replace( "/type=['\"]text\/(javascript|css)['\"]/", '', $tag );
	}
}