<?php
/**
 * The template for displaying all single posts
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#single-post
 *
 * @package iMate
 */

get_header(); ?>

	<main class="main-row">
		<?php if(!empty(imate_styles()['blog_top_background'])) { ?>
			<div class="page-feature-image <?php echo esc_attr(imate_styles()['header_color_mode']) ?>" style="background-image: url(<?php echo esc_url(imate_styles()['blog_top_background']) ?>);">
				<div class="container">
					<div class="h1 heading"><?php echo wp_kses_post(imate_styles()['blog_top_heading']) ?></div>
				</div>
			</div>
		<?php } ?>
		<div class="container single-post-container">
			<?php if(is_active_sidebar('sidebar')) {
				echo '<div class="row">';
				echo '<div class="col-xs-12 col-md-12">';
			}
			while ( have_posts() ) : the_post(); ?>
				<div id="post-<?php the_ID(); ?>" <?php post_class('post-container') ?>>
					<?php 
						$id = get_the_ID();

						$item = get_post($id);

						$thumb = get_post_meta( $id, '_thumbnail_id', true );

						$category = "";
						$category_name = "";
						$category_links_html = "";
						if(is_array(get_the_category($id)) && count(get_the_category($id)) > 0 && get_the_category($id)) {
							foreach (get_the_category($id) as $item) {
								$category .= $item->slug.' ';
								$category_name .= $item->name.', ';
								$category_links_html .= '<a href="'.esc_url(get_category_link($item->cat_ID)).'">'.esc_html($item->name).'</a>';
							}
							$category_name = trim($category_name, ', ');
						}

						$tags_html = "";
						if(is_array(get_the_tags($id)) && count(get_the_tags($id)) > 0 && get_the_tags($id)) {
							foreach (get_the_tags($id) as $tag){
								$tag_link = get_tag_link($tag->term_id);

								$tags_html .= '<a href="'.$tag_link.'">'.$tag->name.'</a>, ';
							}
							$tags_html = trim($tags_html, ', ');
						}

						$prev = get_permalink(get_adjacent_post(false,'',false));
						$next = get_permalink(get_adjacent_post(false,'',true));
					
					if(!empty($thumb) && imate_styles()['blog_feature_image'] == 'show') { ?>
						<div class="post-img bd-item"><?php echo wp_kses_post(wp_get_attachment_image($thumb, '')); ?></div>
					<?php } ?>
					<div class="page-title">
						<h1 class="h4 heading"><?php echo esc_html(single_post_title()); ?></h1>
					</div>
					<?php if(imate_styles()['blog_date'] == 'show' || (!empty($category_name) && imate_styles()['blog_category'] == 'show')) { ?>
						<div class="blog-detail">
							<?php if(imate_styles()['blog_date'] == 'show') { ?>
								<div class="bd-item"><i class="material-design-icon-history-clock-button"></i><span><?php the_date() ?></span></div>
							<?php } if(!empty($category_name) && imate_styles()['blog_category'] == 'show') { ?>
								<div class="bd-item"><i class="material-design-icon-label-right-arrow-outline"></i><span><?php echo strip_tags($category_name) ?></span></div>
							<?php } ?>
						</div>
					<?php } ?>
					<div class="site-content">
						<div class="post-content single">
							<div class="clearfix">
								<?php the_content(''); ?>
							</div>
							<?php if(function_exists('wp_link_pages')) { ?>
								<?php wp_link_pages(array('before' => '<div class="pagination">', 'after' => '</div>','link_before' => '<span>','link_after' => '</span>',)); ?>
							<?php } ?>
						</div>
					</div>
					<div class="post-bottom clearfix">
						<?php if(function_exists('zilla_likes') && imate_styles()['blog_like'] == 'show') {
							echo zilla_likes($id);
						} ?>
						<div class="fr">
							<?php if(function_exists('pt_share_buttons')) {
	                            echo '<div class="share-button"><i class="base-icons-share"></i><div class="w">'.pt_share_buttons($id).'</div></div>';
	                        } if(!empty($category_links_html)) { ?>
	                        	<div class="categs"><?php echo wp_kses_post($category_links_html) ?></div>
	                        <?php } ?>
                        </div>
					</div>
				</div>
				<?php if ( comments_open() || get_comments_number() ) :
					comments_template();
				endif; ?>
			<?php endwhile;

			if(is_active_sidebar('sidebar')) {
				/* echo '</div>';
				echo '<div class="s-sidebar col-xs-12 col-md-4">';
					echo '<div class="w">';
						dynamic_sidebar('sidebar');
					echo '</div>';
				echo '</div>';
				echo '</div>'; */
			} ?>

		</div>
	</main>

<?php
get_footer();
