<?php

// Element Description: PT Num Box

class PT_Num_Box_With_Icon extends WPBakeryShortCode {
     
    // Element Init
    function __construct() {
        add_action( 'init', array( $this, 'pt_num_box_with_icon_mapping' ) );
        add_shortcode( 'pt_num_box_with_icon', array( $this, 'pt_num_box_with_icon_html' ) );
        add_shortcode( 'pt_num_box_with_icon_item', array( $this, 'pt_num_box_with_icon_item_html' ) );
    }
     
    // Element Mapping
    public function pt_num_box_with_icon_mapping() {
         
        // Stop all if VC is not enabled
        if ( !defined( 'WPB_VC_VERSION' ) ) {
            return;
        }
         
        // Map the block with vc_map()
        vc_map( array(
            "name" => esc_html__("Num Box with Icon", "imate"),
            "base" => "pt_num_box_with_icon",
            "as_parent" => array('only' => 'pt_num_box_with_icon_item'),
            "content_element" => true,
            "show_settings_on_create" => true,
            "icon" => "shortcode-icon-num-box-with-icon",
            "is_container" => true,
            "category" => esc_html__("By PT", "imate"),
            "params" => array(
                array(
                    "type"        => "dropdown",
                    "heading"     => esc_html__( "Align", "imate" ),
                    "param_name"  => "align",
                    "value"      => array(
                        esc_html__( "Left", "imate" ) => "tal",
                        esc_html__( "Center", "imate" ) => "tac",
                        esc_html__( "Right", "imate" ) => "tar",
                    ),
                    "std" => 'tac',
                ),
                array(
                    "type" => "colorpicker",
                    "heading" => esc_html__( "Icon Color", "imate" ),
                    "param_name" => "icon_color",
                ),
                array(
                    "type" => "colorpicker",
                    "heading" => esc_html__( "Num Color", "imate" ),
                    "param_name" => "num_color",
                ),
                array(
                    "type" => "colorpicker",
                    "heading" => esc_html__( "Heading Color", "imate" ),
                    "param_name" => "heading_color",
                ),
                array(
                    'type' => 'css_editor',
                    'heading' => esc_html__( 'CSS box', 'imate' ),
                    'param_name' => 'css',
                    'group' => esc_html__( 'Design Options', 'imate' ),
                ),
                array(
                    "type" => "animation_style",
                    "heading" => esc_html__( "Animation In", "imate" ),
                    "param_name" => "animation",
                ),
            ),
            "js_view" => 'VcColumnView'
        ) );
        vc_map( array(
            "name" => esc_html__("Num Box with Icon item", "imate"),
            "base" => "pt_num_box_with_icon_item",
            "content_element" => true,
            "show_settings_on_create" => true,
            "icon" => "shortcode-icon-num-box-with-icon",
            "as_child" => array('only' => 'pt_num_box_with_icon'),
            "params" => array(
                array(
                    'type' => 'dropdown',
                    'heading' => esc_html__( 'Icon library', 'imate' ),
                    'value' => array(
                        esc_html__( 'Font Awesome', 'imate' ) => 'fontawesome',
                        esc_html__( 'Open Iconic', 'imate' ) => 'openiconic',
                        esc_html__( 'Typicons', 'imate' ) => 'typicons',
                        esc_html__( 'Entypo', 'imate' ) => 'entypo',
                        esc_html__( 'Linecons', 'imate' ) => 'linecons',
                        esc_html__( 'Mono Social', 'imate' ) => 'monosocial',
                        esc_html__( 'Material', 'imate' ) => 'material',
                    ),
                    'admin_label' => true,
                    'param_name' => 'type',
                    'description' => esc_html__( 'Select icon library.', 'imate' ),
                ),
                array(
                    'type' => 'iconpicker',
                    'heading' => esc_html__( 'Icon', 'imate' ),
                    'param_name' => 'icon_fontawesome',
                    'value' => 'fa fa-adjust',
                    'settings' => array(
                        'emptyIcon' => false,
                        'iconsPerPage' => 4000,
                    ),
                    'dependency' => array(
                        'element' => 'type',
                        'value' => 'fontawesome',
                    ),
                    'description' => esc_html__( 'Select icon from library.', 'imate' ),
                ),
                array(
                    'type' => 'iconpicker',
                    'heading' => esc_html__( 'Icon', 'imate' ),
                    'param_name' => 'icon_openiconic',
                    'value' => 'vc-oi vc-oi-dial',
                    'settings' => array(
                        'emptyIcon' => false,
                        'type' => 'openiconic',
                        'iconsPerPage' => 4000,
                    ),
                    'dependency' => array(
                        'element' => 'type',
                        'value' => 'openiconic',
                    ),
                    'description' => esc_html__( 'Select icon from library.', 'imate' ),
                ),
                array(
                    'type' => 'iconpicker',
                    'heading' => esc_html__( 'Icon', 'imate' ),
                    'param_name' => 'icon_typicons',
                    'value' => 'typcn typcn-adjust-brightness',
                    'settings' => array(
                        'emptyIcon' => false,
                        'type' => 'typicons',
                        'iconsPerPage' => 4000,
                    ),
                    'dependency' => array(
                        'element' => 'type',
                        'value' => 'typicons',
                    ),
                    'description' => esc_html__( 'Select icon from library.', 'imate' ),
                ),
                array(
                    'type' => 'iconpicker',
                    'heading' => esc_html__( 'Icon', 'imate' ),
                    'param_name' => 'icon_entypo',
                    'value' => 'entypo-icon entypo-icon-note',
                    'settings' => array(
                        'emptyIcon' => false,
                        'type' => 'entypo',
                        'iconsPerPage' => 4000,
                    ),
                    'dependency' => array(
                        'element' => 'type',
                        'value' => 'entypo',
                    ),
                ),
                array(
                    'type' => 'iconpicker',
                    'heading' => esc_html__( 'Icon', 'imate' ),
                    'param_name' => 'icon_linecons',
                    'value' => 'vc_li vc_li-heart',
                    'settings' => array(
                        'emptyIcon' => false,
                        'type' => 'linecons',
                        'iconsPerPage' => 4000,
                    ),
                    'dependency' => array(
                        'element' => 'type',
                        'value' => 'linecons',
                    ),
                    'description' => esc_html__( 'Select icon from library.', 'imate' ),
                ),
                array(
                    'type' => 'iconpicker',
                    'heading' => esc_html__( 'Icon', 'imate' ),
                    'param_name' => 'icon_monosocial',
                    'value' => 'vc-mono vc-mono-fivehundredpx',
                    'settings' => array(
                        'emptyIcon' => false,
                        'type' => 'monosocial',
                        'iconsPerPage' => 4000,
                    ),
                    'dependency' => array(
                        'element' => 'type',
                        'value' => 'monosocial',
                    ),
                    'description' => esc_html__( 'Select icon from library.', 'imate' ),
                ),
                array(
                    'type' => 'iconpicker',
                    'heading' => esc_html__( 'Icon', 'imate' ),
                    'param_name' => 'icon_material',
                    'value' => 'vc-material vc-material-cake',
                    'settings' => array(
                        'emptyIcon' => false,
                        'type' => 'material',
                        'iconsPerPage' => 4000,
                    ),
                    'dependency' => array(
                        'element' => 'type',
                        'value' => 'material',
                    ),
                    'description' => esc_html__( 'Select icon from library.', 'imate' ),
                ),
                array(
                    "type" => "number",
                    "heading" => esc_html__("Num", "imate"),
                    "param_name" => "num",
                    "admin_label" => true,
                ),
                array(
                    "type" => "textarea",
                    "heading" => esc_html__("Heading", "imate"),
                    "param_name" => "heading",
                    "admin_label" => true,
                ),
            )
        ) );
    }
     
     
    // Element HTML
    public function pt_num_box_with_icon_html( $atts, $content = null ) {
         
        // Params extraction
        extract(
            shortcode_atts(
                array(
                    'uniq_id' => uniqid(),
                    'align' => 'tac',
                    'num_color' => '',
                    'heading_color' => '',
                    'css' => '',
                    'animation' => ''
                ), 
                $atts
            )
        );

        $item_class = $id = uniqid('num-box-');

        $item_class .= ' '.$align;

        if(!empty($css)) {
            $item_class .= ' '.vc_shortcode_custom_css_class( $css, ' ' );
        }

        if(!empty($animation)) {
            $item_class .= ' '.$this->getCSSAnimation($animation);
        }

        $html = "";

        // Fill $html var with data
        $custom_css = "";

        if(!empty($num_color)) {
            $custom_css .= '.'.$id.' .num-box-item .num-wrap {
                color: '.$num_color.';
            }';
        }

        if(!empty($heading_color)) {
            $custom_css .= '.'.$id.' .num-box-item .h {
                color: '.$heading_color.';
            }';
        }

        if(!empty($custom_css)) {
            wp_enqueue_style( 'imate-custom-style', get_template_directory_uri() . '/css/custom_script.css' );
            wp_add_inline_style( 'imate-custom-style', $custom_css );
        }

        ob_start();
        ?>

        <div class="num-box with-icon <?php echo esc_attr($item_class) ?>">
            <?php echo do_shortcode($content) ?>
        </div>
         
        <?php
        return ob_get_clean();
         
    }

    // Element HTML
    public function pt_num_box_with_icon_item_html( $atts ) {
         
        // Params extraction
        extract(
            shortcode_atts(
                array(
                    'type' => 'fontawesome',
                    'icon_fontawesome' => 'fa fa-adjust',
                    'icon_openiconic' => 'vc-oi vc-oi-dial',
                    'icon_typicons' => 'typcn typcn-adjust-brightness',
                    'icon_entypo' => 'entypo-icon entypo-icon-note',
                    'icon_linecons' => 'vc_li vc_li-heart',
                    'icon_monosocial' => 'vc-mono vc-mono-fivehundredpx',
                    'icon_material' => 'vc-material vc-material-cake',
                    'num' => '',
                    'icon_color' => '',
                    'heading' => '',
                ), 
                $atts
            )
        );

        $icon = 'icon_'.$type;

        ob_start();
        
        if(!empty($num)) { ?>

            <div class="num-box-item">
                <?php if(isset($$icon) && !empty($$icon)) { ?>
                    <div class="icon <?php echo esc_attr($$icon) ?>"></div>
                <?php } ?>
                <div class="wrap">
                    <div class="num"><?php echo strip_tags($num) ?></div>
                    <?php if(!empty($heading)) { ?>
                        <div class="h"><?php echo wp_kses_post($heading) ?></div>
                    <?php } ?>
                </div>
            </div>

        <?php }

        return ob_get_clean();
         
    }
     
} // End Element Class
 
 
// Element Class Init
new PT_Num_Box_With_Icon();    
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
    class WPBakeryShortCode_PT_Num_Box_With_Icon extends WPBakeryShortCodesContainer {
    }
}
if ( class_exists( 'WPBakeryShortCode' ) ) {
    class WPBakeryShortCode_PT_Num_Box_With_Icon_Item extends WPBakeryShortCode {
    }
}

