<?php

// Element Description: PT Price List Type 2

class PT_Price_List_Type2 extends WPBakeryShortCode {
     
    // Element Init
    function __construct() {
        add_action( 'init', array( $this, 'pt_price_list_type2_mapping' ) );
        add_shortcode( 'pt_price_list_type2', array( $this, 'pt_price_list_type2_html' ) );
        add_shortcode( 'pt_price_list_type2_item', array( $this, 'pt_price_list_type2_item_html' ) );
    }
     
    // Element Mapping
    public function pt_price_list_type2_mapping() {
         
        // Stop all if VC is not enabled
        if ( !defined( 'WPB_VC_VERSION' ) ) {
            return;
        }
         
        // Map the block with vc_map()
        vc_map( array(
            "name" => esc_html__("Price List Type 2", "imate"),
            "base" => "pt_price_list_type2",
            "as_parent" => array('only' => 'pt_price_list_type2_item'),
            "content_element" => true,
            "show_settings_on_create" => true,
            "icon" => "shortcode-icon-price-list-type2",
            "is_container" => true,
            "category" => esc_html__("By PT", "imate"),
            "params" => array(
                array(
                    "type"        => "textfield",
                    "heading"     => esc_html__( "Uniq ID", "imate" ),
                    "param_name"  => "uniq_id",
                    "value"       => uniqid(),
                ),
                array(
                    "type"        => "dropdown",
                    "heading"     => esc_html__( "Desktop", "imate" ),
                    "param_name"  => "desktop_cols",
                    "value"      => array(
                        esc_html__( "Col 1", "imate" ) => "1",
                        esc_html__( "Col 2", "imate" ) => "2",
                        esc_html__( "Col 3", "imate" ) => "3",
                        esc_html__( "Col 4", "imate" ) => "4",
                    ),
                    "std" => '3',
                ),
                array(
                    "type"        => "dropdown",
                    "heading"     => esc_html__( "Tablet", "imate" ),
                    "param_name"  => "tablet_cols",
                    "value"      => array(
                        esc_html__( "Col 1", "imate" ) => "1",
                        esc_html__( "Col 2", "imate" ) => "2",
                        esc_html__( "Col 3", "imate" ) => "3",
                        esc_html__( "Col 4", "imate" ) => "4",
                    ),
                    "std" => '2',
                ),
                array(
                    "type"        => "dropdown",
                    "heading"     => esc_html__( "Mobile", "imate" ),
                    "param_name"  => "mobile_cols",
                    "value"      => array(
                        esc_html__( "Col 1", "imate" ) => "1",
                        esc_html__( "Col 2", "imate" ) => "2",
                        esc_html__( "Col 3", "imate" ) => "3",
                        esc_html__( "Col 4", "imate" ) => "4",
                    ),
                    "std" => '1',
                ),
                array(
                    "type"        => "switch",
                    "heading"     => esc_html__( "Navigation Arrows", "imate" ),
                    "param_name"  => "nav_buttons",
                    "value"       => "on",
                    "options"     => array(
                        "on" => array(
                            "on"    => esc_html__( "On", "imate" ),
                            "off"   => esc_html__( "Off", "imate" ),
                        ),
                    ),
                    "default_set" => true,
                    "dependency"  => Array( "element" => "carousel_mode", "value" => array( "on" ) ),
                    "group"       => esc_html__( "Carousel settings", "imate" ),
                ),
                array(
                    "type" => "colorpicker",
                    "heading" => esc_html__("Arrows color", "imate"),
                    "dependency"  => Array( "element" => "nav_buttons", "value" => array( "on" ) ),
                    "param_name" => "arrows_color",
                    "group"       => esc_html__( "Carousel settings", "imate" ),
                ),
                array(
                    "type"        => "switch",
                    "heading"     => esc_html__( "Autoplay", "imate" ),
                    "param_name"  => "autoplay",
                    "value"       => "off",
                    "options"     => array(
                        "on" => array(
                            "on"    => esc_html__( "On", "imate" ),
                            "off"   => esc_html__( "Off", "imate" ),
                        ),
                    ),
                    "default_set" => false,
                    "dependency"  => Array( "element" => "carousel_mode", "value" => array( "on" ) ),
                    "group"       => esc_html__( "Carousel settings", "imate" ),
                ),
                array(
                    "type"        => "number",
                    "heading"     => esc_html__( "Autoplay timeout", "imate" ),
                    "param_name"  => "autoplay_timeout",
                    "value"       => '5000',
                    "dependency"  => Array( "element" => "carousel_mode", "value" => array( "on" ) ),
                    "group"       => esc_html__( "Carousel settings", "imate" ),
                ),
                array(
                    'type' => 'css_editor',
                    'heading' => esc_html__( 'CSS box', 'imate' ),
                    'param_name' => 'css',
                    'group' => esc_html__( 'Design Options', 'imate' ),
                ),
            ),
            "js_view" => 'VcColumnView'
        ) );
        vc_map( array(
            "name" => esc_html__("Price List Type 2 item", "imate"),
            "base" => "pt_price_list_type2_item",
            "content_element" => true,
            "show_settings_on_create" => true,
            "icon" => "shortcode-icon-price-list-type2",
            "as_child" => array('only' => 'pt_price_list_type2'),
            "params" => array(
                array(
                    "type" => "attach_image",
                    "heading" => esc_html__("Background image", "imate"),
                    "param_name" => "background_image",
                    "dependency" => Array("element" => "background_type", "value" => "image" ),
                ),
                array(
                    "type" => "textarea",
                    "heading" => esc_html__("Heading", "imate"),
                    "param_name" => "heading",
                    "admin_label" => true,
                ),
                array(
                    "type" => "textarea",
                    "heading" => esc_html__("Price Period", "imate"),
                    "param_name" => "period",
                ),
                array(
                    "type" => "textfield",
                    "heading" => esc_html__("Price", "imate"),
                    "param_name" => "price",
                    "admin_label" => true,
                    "description" => __('<b>Example:</b> {$} 490', "imate"),
                ),
                array(
                    "type" => "colorpicker",
                    "heading" => esc_html__("Accent Color", "imate"),
                    "param_name" => "accent_color",
                ),
                array(
                    "type" => "textarea",
                    "heading" => esc_html__("Options", "imate"),
                    "param_name" => "options",
                    "description" => esc_html__("New per row", "imate"),
                ),
                array(
                    "type" => "vc_link",
                    "heading" => esc_html__("Custom link", "imate"),
                    "param_name" => "custom_link",
                ),
            )
        ) );
    }
     
     
    // Element HTML
    public function pt_price_list_type2_html( $atts, $content = null ) {
         
        // Params extraction
        extract(
            shortcode_atts(
                array(
                    'uniq_id' => uniqid(),
                    'desktop_cols' => '3',
                    'tablet_cols' => '2',
                    'mobile_cols' => '1',
                    'carousel_mode' => 'off',
                    'nav_buttons' => 'on',
                    'arrows_color' => '',
                    'autoplay' => 'off',
                    'autoplay_timeout' => '5000',
                    'css' => '',
                ), 
                $atts
            )
        );

        $custom_css = '';

        $item_class = $id = 'price-list-'.$uniq_id;

        if(!empty($css)) {
            $item_class .= ' '.vc_shortcode_custom_css_class( $css, ' ' );
        }

        if($carousel_mode == "on") {
            if($nav_buttons == 'on') {
                $arrows = 'true';
            } else {
                $arrows = 'false';
            }

            if($autoplay == 'on') {
                $autoplay = 'true';
            } else {
                $autoplay = 'false';
            }

            $item_class .= ' disable-iso';

            wp_enqueue_style( 'owl-carousel-css', get_template_directory_uri() . '/css/owl.carousel.css');
            wp_enqueue_script( 'owl-carousel-js', get_template_directory_uri() . '/js/owl.carousel.min.js', array('jquery'), true );
            wp_enqueue_script( 'imate-script', get_template_directory_uri() . '/js/script.js' );

            wp_add_inline_script('imate-script', "jQuery(document).ready(function(jQuery) {
                jQuery('.".esc_attr($id)."').each(function(){
                    var head_slider = jQuery(this);
                    if(jQuery(this).find('.price-list-item').length > 1){
                        head_slider.addClass('owl-carousel').owlCarousel({
                            loop:true,
                            items:1,
                            nav: ".esc_js($arrows).",
                            dots: false,
                            autoplay: ".esc_js($autoplay).",
                            autoplayTimeout: ".esc_js($autoplay_timeout).",
                            autoplayHoverPause: true,
                            navClass: ['owl-prev base-icons-back','owl-next base-icons-next-1'],
                            navText: false,
                            margin: 30,
                            responsive:{
                                0:{
                                    nav: false,
                                    items: 1
                                },
                                768:{
                                    nav: ".esc_js($arrows).",
                                    items: ".esc_js($mobile_cols)."
                                },
                                992:{
                                    items: ".esc_js($tablet_cols)."
                                },
                                1200:{
                                    items: ".esc_js($desktop_cols)."
                                },
                            },
                        });
                    }
                });
            });");
        }

        if(!empty($arrows_color)) {
            $custom_css .= '.'.$id.' .owl-nav > * { color: '.$arrows_color.'; }';
        }

        if(!empty($custom_css)) {
            wp_enqueue_style('imate-custom-style', get_template_directory_uri() . '/css/custom_script.css');
            wp_add_inline_style( 'imate-custom-style', $custom_css );
        }
        
        if(!empty($content)) {
            $content = str_replace('[pt_price_list_type2_item', '[pt_price_list_type2_item carousel_mode="'.esc_attr($carousel_mode).'" desktop_cols="'.esc_attr($desktop_cols).'" tablet_cols="'.esc_attr($tablet_cols).'" mobile_cols="'.esc_attr($mobile_cols).'"', $content);
        }
        // Fill $html var with data
        
        ob_start();
        ?>

        <div class="price-list type2 row <?php echo esc_attr($item_class) ?>">
            <?php echo do_shortcode($content) ?>
        </div>
        
        <?php
        return ob_get_clean();
         
    }

    // Element HTML
    public function pt_price_list_type2_item_html( $atts ) {
         
        // Params extraction
        extract(
            shortcode_atts(
                array(
                    'background_image' => '',
                    'heading' => '',
                    'price' => '',
                    'accent_color' => '',
                    'period' => '',
                    'options' => '',
                    'custom_link' => '',
                    'link_color' => '',
                    'carousel_mode' => 'off',
                    'desktop_cols' => '3',
                    'tablet_cols' => '2',
                    'mobile_cols' => '1',
                ), 
                $atts
            )
        );
         
        // Fill $html var with data

        $image_bg = $custom_css = $link = $options_html = "";
        $item_css = $item_id = uniqid('price-list-item-');

        if($carousel_mode == 'off') {
            $item_css .= ' col-xs-'.esc_attr(12/$mobile_cols).' col-sm-'.esc_attr(12/$tablet_cols).' col-md-'.esc_attr(12/$desktop_cols);
        }

        if(isset(wp_get_attachment_image_src($background_image, 'full')[0])) {
            $image_bg = 'background-image: url('.esc_url(wp_get_attachment_image_src($background_image, 'full')[0]).');';
        }

        if(isset(vc_build_link($custom_link)['url']) && !empty(vc_build_link($custom_link)['url'])) {
            $link = vc_build_link($custom_link);

            if(empty($link['target'])) {
                $link['target'] = '_self';
            }
            if(empty($link['title'])) {
                $link['title'] = esc_html__('Purchase', 'imate');
            }
        }

        if($options) {
            $options = strip_tags($options);
            $options = preg_split('/\r\n|[\r\n]/', $options);

            foreach ($options as $option) {
                $option = str_replace(array('{', '}'), array('<span>', '</span>'), $option);
                $options_html .= '<div class="o-row"><span>'.$option.'</span></div>';
            }
        }

        if(!empty($accent_color)) {
            $custom_css .= '.price-list-item.'.$item_id.' .price-area .price, .price-list-item.'.$item_id.' .wrap .top { color: '.$accent_color.'; }';
            $custom_css .= '.price-list-item.'.$item_id.' .button .button-style2 { background-color: '.$accent_color.'; }';
        }

        if(!empty($custom_css)) {
            wp_enqueue_style('imate-custom-style', get_template_directory_uri() . '/css/custom_script.css');
            wp_add_inline_style( 'imate-custom-style', $custom_css );
        }

        if(!empty($price)) {
            $price = str_replace(array('{', '}'), array('<span>', '</span>'), $price);
        }

        ob_start();
        ?>
        <div class="price-list-item <?php echo esc_attr($item_css) ?>">
            <div class="wrap">
                <div class="top" style="<?php echo esc_attr($image_bg) ?>">
                    <div class="cell">
                        <?php if(!empty($heading)) { ?>
                            <h4 class="heading"><?php echo wp_kses_post($heading) ?></h4>
                        <?php } if(!empty($period)) { ?>
                            <div class="period"><?php echo wp_kses_post($period) ?></div>
                        <?php } ?>
                    </div>
                </div>
                <?php if(!empty($price)) { ?>
                    <div class="price-area">
                        <div class="price"><?php echo wp_kses_post($price) ?></div>
                    </div>
                <?php } if(!empty($options_html)) { ?>
                    <div class="options">
                        <?php echo wp_kses_post($options_html) ?>
                    </div>
                <?php } if(!empty($link) && is_array($link)) { ?>
                    <div class="button"><a href="<?php echo esc_url($link['url']) ?>" class="button-style2 button-with-icon" target="<?php echo esc_attr($link['target']) ?>"><span><?php echo wp_kses_post($link['title']) ?></span><i class="fa fa-angle-right"></i></a></div>
                <?php } ?>
            </div>
        </div>
        <?php
        return ob_get_clean();
         
    }
     
} // End Element Class
 
 
// Element Class Init
new PT_Price_List_Type2();    
if ( class_exists( 'WPBakeryShortCodesContainer' ) ) {
    class WPBakeryShortCode_PT_Price_List_Type2 extends WPBakeryShortCodesContainer {
    }
}
if ( class_exists( 'WPBakeryShortCode' ) ) {
    class WPBakeryShortCode_PT_Price_List_Type2_Item extends WPBakeryShortCode {
    }
}

