<?php

// Element Description: PT Wave

class PT_Wave extends WPBakeryShortCode {
     
    // Element Init
    function __construct() {
        add_action( 'init', array( $this, 'pt_wave_mapping' ) );
        add_shortcode( 'pt_wave', array( $this, 'pt_wave_html' ) );
    }
     
    // Element Mapping
    public function pt_wave_mapping() {
         
        // Stop all if VC is not enabled
        if ( !defined( 'WPB_VC_VERSION' ) ) {
            return;
        }
         
        // Map the block with vc_map()
        vc_map( array(
            "name" => esc_html__("Wave", "imate"),
            "base" => "pt_wave",
            "show_settings_on_create" => true,
            "icon" => "shortcode-icon-wave",
            "category" => esc_html__("By PT", "imate"),
            "params" => array(
                array(
                    "type"        => "dropdown",
                    "heading"     => esc_html__( "Style", "imate" ),
                    "param_name"  => "style",
                    "value"      => array(
                        esc_html__( "Style 1", "imate" ) => "style",
                        esc_html__( "Style 2", "imate" ) => "style2",
                        esc_html__( "Style 3", "imate" ) => "style3",
                        esc_html__( "Style 4", "imate" ) => "style4",
                        esc_html__( "Style 5", "imate" ) => "style5",
                        esc_html__( "Style 6", "imate" ) => "style6",
                    ),
                ),
                array(
                    'type' => 'css_editor',
                    'heading' => esc_html__( 'CSS box', 'imate' ),
                    'param_name' => 'css',
                    'group' => esc_html__( 'Design Options', 'imate' ),
                ),
                array(
                    "type" => "animation_style",
                    "heading" => esc_html__( "Animation In", "imate" ),
                    "param_name" => "animation",
                ),
            ),
        ) );
    }
     
     
    // Element HTML
    public function pt_wave_html( $atts, $content = null ) {
         
        // Params extraction
        extract(
            shortcode_atts(
                array(
                    'style' => 'style',
                    'css' => '',
                    'animation' => '',
                ), 
                $atts
            )
        );

        $class = $id = uniqid('wave-block-');

        $class .= ' wave-'.$style;

        if(!empty($css)) {
            $class .= ' '.vc_shortcode_custom_css_class( $css, ' ' );
        }

        if(!empty($animation)) {
            $class .= ' '.$this->getCSSAnimation($animation);
        }

        ob_start();
        ?>

            <div class="wave-area">
                <div class="wave-block <?php echo esc_attr($class) ?>"></div>
            </div>
        
        <?php
        return ob_get_clean();
    }

} // End Element Class
 
 
// Element Class Init
new PT_Wave();